image: maven:3-jdk-11
variables:
  MAVEN_OPTS: "-Dhttps.protocols=TLSv1.2 -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true  -Djava.awt.headless=true"
  MAVEN_CLI_OPTS: "--batch-mode --errors --show-version -DinstallAtEnd=true -DdeployAtEnd=true"
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
  DOCKER_TLS_CERTDIR: ""
stages:
    - build
    - test
    - sonar
    - build_docker_image
#build stage test
cache:
    paths:
        - .m2/repository
    key: "${CI_JOB_NAME}"
maven_build_job:
    stage: build
    script:
        - echo 'Maven build job started'
        - echo $CI_COMMIT_REF_NAME
        - echo $CI_COMMIT_TAG
        - mvn $MAVEN_CLI_OPTS validate
        - cd $CI_PROJECT_DIR
        - mvn $MAVEN_CLI_OPTS clean package
    artifacts:
        expire_in: 60 min
        paths:
            - target/*.jar
    except:
        - master
##test stage
test_all_job:
    when: always
    stage: test
    except:
      - master
    script:
        - mvn $MAVEN_CLI_OPTS clean test
    artifacts:
      reports:
        junit:
          - target/surefire-reports/TEST-*.xml
test_unit_job:
    when: always
    stage: test
    only:
     - master
    script:
        - mvn clean compile install -DskipTests
        - cp target/tpAchatProject-1.0.jar tpAchatProject-1.0-${CI_COMMIT_SHA}.jar
    artifacts:
            name: tpAchatProject-1.0
            expire_in: 1 week
            paths:
               - tpAchatProject-1.0-${CI_COMMIT_SHA}.jar
#Sonar_Quality_Code
sonar_job:
  when: always
  stage: sonar
  cache:
    paths:
      - .sonar/cache
      - .m2/repository
  script:
    - echo ${CI_JOB_NAME}
    - echo 'sonar job'
    - mvn verify sonar:sonar -Dsonar.organization=farouk-hajjej -Dsonar.projectKey=farouk.hajjej_test-project
  except:
    - master
#stage build docker image
build docker image:
  stage: build_docker_image
  image: docker:19.03.12
  services:
    - docker:19.03.12-dind
  before_script:
    -  docker login -u "$CI_REGISTRY_USER" -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  variables:
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: ""
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
  script:
      - docker build -t $IMAGE_TAG -f ./Dockerfile .
      - docker push $IMAGE_TAG
  only:
    - farouk-branch
#docker compose
#docker_compose:
 # stage: docker_compose
  #image: docker/compose:latest
  #services:
   # - docker:19.03.12-dind
  #script:
   # - docker-compose -f ./docker-compose.yml up -d --build
  #environment:
   # name: production
    #url: http://192.168.33.10:8089/SpringMVC/swagger-ui/index.html#/

#deploy_gke:
# when: manual
#  stage: deploy
# image: google/cloud-sdk:latest
 # variables:
    #IMAGE_TAG: £CI_REGISTRY_IMAGE/$
